//
//  Budget.swift
//  ydnab
//
//  Created by Andrea Franceschini on 22/09/2020.
//

import Foundation

struct BudgetCategory: Codable, Identifiable {
    var id: UUID = UUID()
    var name: String = ""
    var hidden: Bool = false
}

struct BudgetSection: Codable, Identifiable {
    var id: UUID = UUID()
    var name: String = ""
    var hidden: Bool = false
    var categories: [BudgetCategory] = []
}

//typealias BudgetStructure = [BudgetSection]

struct BudgetInfo: Codable, Identifiable {
    var id = UUID()
    var name: String = ""
    var localeIdentifier: String = ""
    var sections: [BudgetSection] = []
}

typealias BudgetsList = [BudgetInfo]
